//
//  DespesesViewController.swift
//  Concot
//
//  Created by Andreu Font Bardolet on 14/5/15.
//  Copyright (c) 2015 Andreu Font Bardolet. All rights reserved.
//

import UIKit
import CoreData

class DespesesViewController: UITableViewController {

    var vehicle: Vehicle!
    var emplenaments: [Emplenament]!

    override func viewDidLoad() {
        super.viewDidLoad()
        
        vehicle = (self.tabBarController as! TabBarController).vehicle
        emplenaments = vehicle.obtenirEmplenaments(false)

    }
    
    override func viewDidAppear(animated: Bool) {
        //vehicle = (self.tabBarController as! TabBarController).vehicle
        emplenaments = vehicle.obtenirEmplenaments(false)
        self.tableView.reloadData()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    // MARK: - Table view data source
    
    override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        // #warning Potentially incomplete method implementation.
        // Return the number of sections.
        return 1
    }

    override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // #warning Incomplete method implementation.
        // Return the number of rows in the section.
        return vehicle.emplenaments?.count ?? 0
    }

    override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCellWithIdentifier("emplenamentCell", forIndexPath: indexPath) as! EmplenamentCell
        
        // Configure the cell...
        self.configurarCelaEmplenament(cell, atIndexPath: indexPath)
        
        return cell
    }
    
    private func configurarCelaEmplenament(cell: EmplenamentCell, atIndexPath indexPath: NSIndexPath) {
        let emplenament = emplenaments[indexPath.row]
        let inxexSeguent=NSIndexPath(forRow: indexPath.row + 1, inSection: indexPath.section)
        var distanciaFeta = 0.0
        
        //return sectionInfo.numberOfObjects
        
        if emplenaments.count > inxexSeguent.row{
            let emplenamentAnterior = emplenaments[inxexSeguent.row]
            distanciaFeta = emplenament.contaquilometres - emplenamentAnterior.contaquilometres
        }
        
        cell.dataLabel!.text = emplenament.obtenirData()
        //let km = Double(distanciaFeta).format("0.1")
        let km = emplenament.distanciaAconseguida.format(".")
        cell.kmRealitzatsLabel!.text = "\(km) \(vehicle.unitatKm)"
        //let kmAcumulats = Double(emplenament.km).format(".1")
        let kmAcumulats = emplenament.contaquilometres.format(".1")
        cell.kmAcumulatsLabel!.text = "\(kmAcumulats) \(vehicle.unitatKm)"
        
        cell.carburantLabel!.text = emplenament.carburant.nom
        
        let cost = Double(emplenament.cost).format(".2")
        cell.costLabel!.text = "\(cost) \(vehicle.moneda)"
        let litres = Double(emplenament.litres).format(".2")
        cell.litresPosatsLabel!.text = "\(litres) \(emplenament.carburant.abreviat)"
        let preu = Double(emplenament.preu).format(".3")
        cell.preuLitreLabel!.text = "\(preu) \(vehicle.moneda)/\(emplenament.carburant.abreviat)"
        
        //if Bool(emplenament.ple) && distanciaFeta > 0.0 {
        //if emplenament.pleBool && emplenament.distanciaAconseguida > 0.0 {
        if emplenament.pleBool {
            let litresPosats = Double(emplenament.litres)
            //let consumDistancia = Double((litresPosats/distanciaFeta)*100).format(".2")
            let consumDistancia = emplenament.consumCada100Distancia?.format(".2") ?? "--"
            cell.litresPerKmLabel!.text = "\(consumDistancia) \(emplenament.carburant.abreviat)/100\(emplenament.unitatDistancia.unitatMesura)"
            
            let preuPagat = Double(emplenament.cost)
            //let monedaDistancia = Double((preuPagat/distanciaFeta)*100).format(".2")
            let monedaDistancia = emplenament.costCada100Distancia?.format(".2") ?? "--"
            cell.monedaPerKmLabel!.text = "\(monedaDistancia) \(vehicle.moneda)/100\(emplenament.unitatDistancia.unitatMesura)"
            
        //} else if distanciaFeta <= 0 {
        }/* else if emplenament.distanciaAconseguida <= 0.0 {
            //cell.litresPerKmLabel!.text = "-- \(Carburants(string: emplenament.carburant.unitatMesura).unitatMesura)/100\(emplenament.unitatDistancia.unitatMesura)"
            cell.litresPerKmLabel!.text = "--"
            //cell.monedaPerKmLabel!.text = "-- \(vehicle.moneda)/100\(emplenament.unitatDistancia.unitatMesura)"
            cell.monedaPerKmLabel!.text = "--"
        }*/ else if emplenament.pleBool != true{
            cell.litresPerKmLabel!.text = "Parcial"
            cell.monedaPerKmLabel!.text = ""
        }
        
        //Més estructurat però més leeeent! 
        /*
        cell.dataLabel!.text = emplenament.dataString
        let kmRealitzats = emplenament.distanciaFeta.format(".1")
        cell.kmRealitzatsLabel!.text = "\(kmRealitzats) \(emplenament.unitatDistancia.unitatMesura)"
        let kmAcumulats = emplenament.contaquilometres.format(".1")
        cell.kmAcumulatsLabel!.text = "\(kmAcumulats) \(emplenament.unitatDistancia.unitatMesura)"

        let cost = emplenament.costDouble.format(".2")
        cell.costLabel!.text = "\(cost) \(emplenament.monedaDet.simbol)"
        let litres = emplenament.quantitat.format(".2")
        cell.litresPosatsLabel!.text = "\(litres) \(emplenament.carburant.plural)"
        let preu = emplenament.preuDouble.format(".3")
        cell.preuLitreLabel!.text = "\(preu) \(emplenament.monedaDet.simbol)/\(emplenament.carburant.abreviat)"
        
        if emplenament.consumCada100Distancia != nil {
            let consumDistancia = emplenament.consumCada100Distancia!.format(".2")
            cell.litresPerKmLabel!.text = "\(consumDistancia) \(emplenament.carburant.abreviat)/100\(emplenament.unitatDistancia.unitatMesura)"
        } else {
            cell.litresPerKmLabel!.text = "Parcial"
        }
        
        if emplenament.costCada100Distancia != nil {
            let costDistancia = emplenament.costCada100Distancia!.format(".2")
            cell.monedaPerKmLabel!.text = "\(costDistancia) \(emplenament.monedaDet.simbol)/100\(emplenament.unitatDistancia.unitatMesura)"
        } else {
            cell.monedaPerKmLabel!.text = ""
        }
        */

    }
    
    // Override to support conditional editing of the table view.
    /*override func tableView(tableView: UITableView, canEditRowAtIndexPath indexPath: NSIndexPath) -> Bool {
        // Return NO if you do not want the specified item to be editable.
        return ture
    }*/
    
    
    
    // Override to support editing the table view.
    override func tableView(tableView: UITableView, commitEditingStyle editingStyle: UITableViewCellEditingStyle, forRowAtIndexPath indexPath: NSIndexPath) {
        if editingStyle == .Delete {
            // Delete the row from the data source
            let appDelegate = (UIApplication.sharedApplication().delegate as! AppDelegate)
            let managedObjectContext = appDelegate.managedObjectContext!
            //context.deleteObject(self.fetchedResultsController.objectAtIndexPath(indexPath) as! NSManagedObject)
            managedObjectContext.deleteObject(emplenaments[indexPath.row])
            
            var error: NSError? = nil
            if !managedObjectContext.save(&error) {
                // Replace this implementation with code to handle the error appropriately.
                // abort() causes the application to generate a crash log and terminate. You should not use this function in a shipping application, although it may be useful during development.
                //println("Unresolved error \(error), \(error.userInfo)")
                abort()
            }
            emplenaments = vehicle.obtenirEmplenaments(false)
            (self.tabBarController as! TabBarController).vehicle = vehicle
            tableView.reloadData()
        }
    }

    
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        // Get the new view controller using [segue destinationViewController].
        // Pass the selected object to the new view controller.
        if segue.identifier == "detallEmplenament" {
            if let desti = segue.destinationViewController.visibleViewController as? EmplenamentController {
                desti.vehicle = self.vehicle
                if let indexPath = self.tableView.indexPathForSelectedRow() {
                    tableView.deselectRowAtIndexPath(indexPath, animated: true)
                    desti.emplenament = emplenaments[indexPath.row]
                }
            }
        }
    }

}
