//
//  EmplenamentController.swift
//  Concot
//
//  Created by Andreu Font Bardolet on 10/6/15.
//  Copyright (c) 2015 Andreu Font Bardolet. All rights reserved.
//

import UIKit
import SwiftForms

class EmplenamentController: FormViewController {

    var vehicle: Vehicle! = nil
    var emplenament: Emplenament! = nil
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.navigationItem.leftBarButtonItem = UIBarButtonItem(title: "Tancar", style: .Plain, target: self, action: "tancar:")
        
        //Emplenem la taula dinàmica amb les dades de l'emplenament
        let seccio1 = FormSectionDescriptor()
        
        seccio1.headerTitle = "Dades emplenament"
        var row: FormRowDescriptor = FormRowDescriptor(tag: "", rowType: .Label, title: "Data")
        row.configuration[FormRowDescriptor.Configuration.CellConfiguration] = ["textField.textAlignment" : NSTextAlignment.Right.rawValue]
        row.value = emplenament.dataString
        seccio1.addRow(row)
        
        row = FormRowDescriptor(tag: "", rowType: .Label, title: "Contaquilòmetres")
        row.configuration[FormRowDescriptor.Configuration.CellConfiguration] = ["textField.textAlignment" : NSTextAlignment.Right.rawValue]
        row.value = emplenament.contaquilometres.format(".2") + " \(Distancia(string: vehicle.unitatKm).unitatMesura)"
        seccio1.addRow(row)
        
        row = FormRowDescriptor(tag: "", rowType: .Label, title: "Quantitat posada")
        row.configuration[FormRowDescriptor.Configuration.CellConfiguration] = ["textField.textAlignment" : NSTextAlignment.Right.rawValue]
        row.value = emplenament.quantitat.format(".2") + " \(Quantitat(string: emplenament.carburant.unitatMesura).unitatMesura)"
        seccio1.addRow(row)
        
        row = FormRowDescriptor(tag: "", rowType: .Label, title: "Cost total")
        row.configuration[FormRowDescriptor.Configuration.CellConfiguration] = ["textField.textAlignment" : NSTextAlignment.Right.rawValue]
        row.value = emplenament.costDouble.format(".2") + " \(emplenament.monedaDet.simbol)"
        seccio1.addRow(row)
        
        row = FormRowDescriptor(tag: "", rowType: .Label, title: "Preu")
        row.configuration[FormRowDescriptor.Configuration.CellConfiguration] = ["textField.textAlignment" : NSTextAlignment.Right.rawValue]
        row.value = emplenament.preuDouble.format(".2") + " \(emplenament.monedaDet.simbol)"
        seccio1.addRow(row)
        
        row = FormRowDescriptor(tag: "", rowType: .Label, title: "Tipus d'emplenament")
        row.configuration[FormRowDescriptor.Configuration.CellConfiguration] = ["textField.textAlignment" : NSTextAlignment.Right.rawValue]
        if emplenament.pleBool {
            row.value = "Dipòsit ple"
        } else {
            row.value = "Dipòsit parcial"
        }
        seccio1.addRow(row)
        
        row = FormRowDescriptor(tag: "", rowType: .Label, title: "Carburant")
        row.configuration[FormRowDescriptor.Configuration.CellConfiguration] = ["textField.textAlignment" : NSTextAlignment.Right.rawValue]
        row.value = Carburants(string: emplenament.carburant.nom).nom
        seccio1.addRow(row)
        
        let seccio2 = FormSectionDescriptor()
        seccio2.headerTitle = "Informació extreta de l'emplenament"
        println(emplenament.seguent)
        if emplenament.pleBool {
            row = FormRowDescriptor(tag: "", rowType: .Label, title: "Distància recorreguda")
            row.configuration[FormRowDescriptor.Configuration.CellConfiguration] = ["textField.textAlignment" : NSTextAlignment.Right.rawValue]
            row.value = emplenament.distanciaAconseguida.format(".2")
            seccio2.addRow(row)
            
            row = FormRowDescriptor(tag: "", rowType: .Label, title: "Consum")
            row.configuration[FormRowDescriptor.Configuration.CellConfiguration] = ["textField.textAlignment" : NSTextAlignment.Right.rawValue]
            row.value = (emplenament.consumCada100Distancia?.format(".2") ?? "--") + " \(emplenament.carburant.unitatMesura)/100\(vehicle.unitatKm)"
            seccio2.addRow(row)
            
            row = FormRowDescriptor(tag: "", rowType: .Label, title: "Cost")
            row.configuration[FormRowDescriptor.Configuration.CellConfiguration] = ["textField.textAlignment" : NSTextAlignment.Right.rawValue]
            row.value = (emplenament.costCada100Distancia?.format(".2") ?? "--") + " \(emplenament.carburant.unitatMesura)/100\(vehicle.unitatKm)"
            seccio2.addRow(row)
        } else {
            seccio2.footerTitle = "No es poden calular detalls d'emplenaments parcials"
        }
        
        
        form.sections = [seccio1, seccio2]
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    required init(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        self.loadForm()
    }
    
    private func loadForm() {
        //Creen el formulari buit, després en el ViewDidLoad es decidirà què s'hi posa
        let form = FormDescriptor()
        self.form = form
    }
    
    func tancar(_: UIBarButtonItem!) {
        dismissViewControllerAnimated(true, completion: nil)
    }
}
