//
//  ExampleData.swift
//  Concot
//
//  Created by Andreu Font Bardolet on 12/5/15.
//  Copyright (c) 2015 Andreu Font Bardolet. All rights reserved.
//

/*
Aquest és el fitxer de la càrrega de dades inicial a Concot, on es generen i carreguen dades exemple de dos vehicles
Al tractar-se d'úna càrrega de dades, no hi ha un codi estructurat o comentat
*/

import Foundation
import UIKit
import CoreData

struct ExampleData {
    
    struct SeguroElements {
        var asseguradora: String = ""
        var pagament: String = ""
        var mesPagament: String = ""
        var preu: Double = 0
        var franquicia: Double? = nil
        var tipus: String? = nil
        var polissa: String? = nil
        var notes: String? = nil
    }
    
    struct Impost {
        var pagament: String = ""
        var mesPagament: String = ""
        var preu: Double = 0
    }
    
    struct NouManteniment {
        var nom: String = ""
        var caducitat: Double = 0
        var distanciaMaxima: Double = 0
    }
    
    struct NouRegistre {
        var distanciaInicial: Double = 0
        var data: NSDate = NSDate()
        var cost: Double = 0
    }
    
    func carregadaDadesExemple() {
        //println("Carregar dades exemple")
        let appDelegate = (UIApplication.sharedApplication().delegate as! AppDelegate)
        let managedObjectContext = appDelegate.managedObjectContext
        
        //Generar i omplir taula de carburants
        for var i=0; i < Carburants().kCarburants.count; ++i {
            let carburantNou = NSEntityDescription.insertNewObjectForEntityForName("Carburant", inManagedObjectContext: managedObjectContext!) as! Carburant
            carburantNou.nom = Carburants(string: Carburants().kCarburants[i]).nom
            carburantNou.unitatMesura = Carburants(string: Carburants().kCarburants[i]).unitatMesura.unitatMesura
        }
        
        //Crear vehicle
        let vehicle = self.generarVehicle(managedObjectContext!)
        let vehicle2 = self.generarVehicle2(managedObjectContext!)
        
        //Afegirm carburants acceptats
        vehicle.carburants = self.generarCarburant(managedObjectContext!, vehicle: vehicle)
        vehicle2.carburants = self.generarCarburant2(managedObjectContext!, vehicle: vehicle2)
        
        //Realitzem emplenaments
        vehicle.emplenaments = self.generarEmplenament(managedObjectContext!, vehicle: vehicle, carburants: vehicle.carburants)
        
        var emplenaments = vehicle2.mutableSetValueForKey("emplenaments")
        var parametres:(String, Double,Double, Double, Emplenament?) = ("09/05/2011",87089.0,22.4,26.858,nil)
        var emplenament = self.generarEmplenament2(managedObjectContext!, vehicle: vehicle2, carburants: vehicle2.carburants, parametres: parametres )
        emplenaments.addObject(emplenament)
        
        parametres = ("16/05/2011",87345.0,15.3,18.345, emplenament)
        emplenament = self.generarEmplenament2(managedObjectContext!, vehicle: vehicle2, carburants: vehicle2.carburants, parametres: parametres )
        emplenaments.addObject(emplenament)
        
        parametres = ("23/05/2011",87692.3,18.7,21.112, emplenament)
        emplenament = self.generarEmplenament2(managedObjectContext!, vehicle: vehicle2, carburants: vehicle2.carburants, parametres: parametres )
        emplenaments.addObject(emplenament)
        
        parametres = ("30/05/2011",88057.3,18.9,21.338, emplenament)
        emplenament = self.generarEmplenament2(managedObjectContext!, vehicle: vehicle2, carburants: vehicle2.carburants, parametres: parametres )
        emplenaments.addObject(emplenament)
        
        parametres = ("06/06/2011",88398.2,19.0,21.641, emplenament)
        emplenament = self.generarEmplenament2(managedObjectContext!, vehicle: vehicle2, carburants: vehicle2.carburants, parametres: parametres )
        emplenaments.addObject(emplenament)
        
        parametres = ("13/06/2011",88805.9,22.3,25.623, emplenament)
        emplenament = self.generarEmplenament2(managedObjectContext!, vehicle: vehicle2, carburants: vehicle2.carburants, parametres: parametres )
        emplenaments.addObject(emplenament)
        
        parametres = ("20/06/2011",89218.9,21.6,24.818, emplenament)
        emplenament = self.generarEmplenament2(managedObjectContext!, vehicle: vehicle2, carburants: vehicle2.carburants, parametres: parametres )
        emplenaments.addObject(emplenament)
        
        parametres = ("27/06/2011",89543.3,18.6,21.557, emplenament)
        emplenament = self.generarEmplenament2(managedObjectContext!, vehicle: vehicle2, carburants: vehicle2.carburants, parametres: parametres )
        emplenaments.addObject(emplenament)
        
        parametres = ("04/07/2011",89904.3,20.3,23.528, emplenament)
        emplenament = self.generarEmplenament2(managedObjectContext!, vehicle: vehicle2, carburants: vehicle2.carburants, parametres: parametres )
        emplenaments.addObject(emplenament)
        
        parametres = ("11/07/2011",90271.4,19.6,22.775, emplenament)
        emplenament = self.generarEmplenament2(managedObjectContext!, vehicle: vehicle2, carburants: vehicle2.carburants, parametres: parametres )
        emplenaments.addObject(emplenament)
        
        parametres = ("18/07/2011",90787.5,27.5,32.093, emplenament)
        emplenament = self.generarEmplenament2(managedObjectContext!, vehicle: vehicle2, carburants: vehicle2.carburants, parametres: parametres )
        emplenaments.addObject(emplenament)
        
        parametres = ("25/07/2011",91378.8,29.2,34.310, emplenament)
        emplenament = self.generarEmplenament2(managedObjectContext!, vehicle: vehicle2, carburants: vehicle2.carburants, parametres: parametres )
        emplenaments.addObject(emplenament)
        
        parametres = ("01/08/2011",91998.4,29.7,35.313, emplenament)
        emplenament = self.generarEmplenament2(managedObjectContext!, vehicle: vehicle2, carburants: vehicle2.carburants, parametres: parametres )
        emplenaments.addObject(emplenament)
        
        parametres = ("08/08/2011",92382.6,19.5,24.668, emplenament)
        emplenament = self.generarEmplenament2(managedObjectContext!, vehicle: vehicle2, carburants: vehicle2.carburants, parametres: parametres )
        emplenaments.addObject(emplenament)
        
        parametres = ("15/08/2011",92847.7,26.4,34.558, emplenament)
        emplenaments.addObject(self.generarEmplenament2(managedObjectContext!, vehicle: vehicle2, carburants: vehicle2.carburants, parametres: parametres ))
        
        vehicle2.emplenaments = emplenaments
        
        
        //Omplir dades d'assegurança
        let parametresSeguro = SeguroElements(asseguradora: "Caser",pagament: "Anual",mesPagament: "Gener",preu: 73.67,franquicia: nil,tipus: "Tercers",polissa: "3759MOT2",notes: "No cobreix zones forestals protegides com a paratge natural")
        vehicle.seguro = self.generarSeguro(managedObjectContext!,parametres: parametresSeguro)
        
        
        let parametresSeguro2 = SeguroElements(asseguradora: "Maphre",pagament: "Anual",mesPagament: "Febrer",preu: 432.27,franquicia: nil,tipus: "Tercers",polissa: "42342GJ343",notes: "En cas d'accident trucar a 902 123 123")
        vehicle2.seguro = self.generarSeguro(managedObjectContext!, parametres: parametresSeguro2)
        
        //Omplir dades Impost
        let impost = Impost(pagament: "Anual",mesPagament: "Març",preu: 11.67)
        vehicle.impostMunicipal = self.generarImpost(managedObjectContext!, parametres: impost)
        
        
        let impost2 = Impost(pagament: "Anual",mesPagament: "Març",preu: 54.38)
        vehicle2.impostMunicipal = self.generarImpost(managedObjectContext!,parametres: impost2)
        
        //Afegir dades manteniment i registres de manteniment
       // var manteniments = vehicle.mutableSetValueForKey("Manteniment")
        let formatter = NSDateFormatter()
        formatter.locale = NSLocale(localeIdentifier: "ES_es")
        formatter.dateFormat = "dd/MM/yyyy"
        let kLlistaTipus = Manteniments().kLlistaTipus
        
        //Manteniment Oli
        var oliMotor = Manteniments(tipus: kLlistaTipus[0]) //12€ posats 0,45l
        oliMotor.placeholder[0] = "0,45"
        oliMotor.placeholder[1] = "API SG, JASO MA-2"
        oliMotor.placeholder[2] = "10w40"
        oliMotor.placeholder[3] = ""
        oliMotor.placeholder[4] = "Castrol"
        oliMotor.placeholder[5] = "MTX 10w40"
        oliMotor.placeholder[6] = "Tri-Shield technology"
        var manteniment = NouManteniment(nom: kLlistaTipus[0], caducitat: 6, distanciaMaxima: 3000)
        //manteniments.addObject(generarManteniment(managedObjectContext!, detalls: oliMotor, dades: manteniment))
        let manOli = generarManteniment(managedObjectContext!, detalls: oliMotor, dades: manteniment, vehicle: vehicle)
        generarRegistreManteniment(managedObjectContext!, manteniment: manOli, dades: NouRegistre(distanciaInicial: 20803, data: formatter.dateFromString("15/06/2014")!, cost: 11.45), vehicle: vehicle)
        generarRegistreManteniment(managedObjectContext!, manteniment: manOli, dades: NouRegistre(distanciaInicial: 22306, data: formatter.dateFromString("23/01/2015")!, cost: 11.65), vehicle: vehicle)
        generarRegistreManteniment(managedObjectContext!, manteniment: manOli, dades: NouRegistre(distanciaInicial: 23049, data: formatter.dateFromString("30/04/2015")!, cost: 11.45), vehicle: vehicle)
        
        //Manteniment Rodes
        var rodes = Manteniments(tipus: kLlistaTipus[9])
        rodes.placeholder[0] = "2"
        rodes.placeholder[1] = "Continental"
        rodes.placeholder[2] = "Soft contact"
        rodes.placeholder[3] = "0"
        rodes.placeholder[4] = "0"
        rodes.placeholder[5] = "0"
        rodes.placeholder[6] = "0"
        rodes.placeholder[7] = ""
        rodes.placeholder[8] = ""
        manteniment = NouManteniment(nom: kLlistaTipus[9], caducitat: 12, distanciaMaxima: 5000)
        //manteniments.addObject(generarManteniment(managedObjectContext!, detalls: rodes, dades: manteniment))
        let manRodes = generarManteniment(managedObjectContext!, detalls: rodes, dades: manteniment, vehicle: vehicle)
        generarRegistreManteniment(managedObjectContext!, manteniment: manRodes, dades: NouRegistre(distanciaInicial: 20803, data: formatter.dateFromString("15/06/2015")!, cost: 67.57), vehicle: vehicle)
        generarRegistreManteniment(managedObjectContext!, manteniment: manRodes, dades: NouRegistre(distanciaInicial: 23049, data: formatter.dateFromString("30/04/2015")!, cost: 74.72), vehicle: vehicle)
        
        //Manteniment filtre
        var filtre = Manteniments(tipus: kLlistaTipus[5])
        manteniment = NouManteniment(nom: kLlistaTipus[5], caducitat: 12, distanciaMaxima: 3000)
        //manteniments.addObject(generarManteniment(managedObjectContext!, detalls: filtre, dades: manteniment))
        let manFiltre = generarManteniment(managedObjectContext!, detalls: filtre, dades: manteniment, vehicle: vehicle)
        generarRegistreManteniment(managedObjectContext!, manteniment: manFiltre, dades: NouRegistre(distanciaInicial: 20803, data: formatter.dateFromString("15/06/2014")!, cost: 8.21), vehicle: vehicle)
        generarRegistreManteniment(managedObjectContext!, manteniment: manFiltre, dades: NouRegistre(distanciaInicial: 22306, data: formatter.dateFromString("23/01/2015")!, cost: 8.23), vehicle: vehicle)
        generarRegistreManteniment(managedObjectContext!, manteniment: manFiltre, dades: NouRegistre(distanciaInicial: 23049, data: formatter.dateFromString("30/04/2015")!, cost: 8.15), vehicle: vehicle)
        
        //vehicle.manteniment = manteniments
        
        
        //Per vehicle 2
        //manteniments = vehicle2.mutableSetValueForKey("Manteniment")
        //Manteniment Oli
        oliMotor = Manteniments(tipus: kLlistaTipus[0])
        manteniment = NouManteniment(nom: kLlistaTipus[0], caducitat: 12, distanciaMaxima: 20000)
        //manteniments.addObject(generarManteniment(managedObjectContext!, detalls: oliMotor, dades: manteniment))
        let manOli2 = generarManteniment(managedObjectContext!, detalls: oliMotor, dades: manteniment, vehicle: vehicle2)
        generarRegistreManteniment(managedObjectContext!, manteniment: manOli2, dades: NouRegistre(distanciaInicial: 92847.7, data: formatter.dateFromString("15/08/2011")!, cost: 26.74), vehicle: vehicle2)
        
        let filtreOliMotor = Manteniments(tipus: kLlistaTipus[7])
        manteniment = NouManteniment(nom: kLlistaTipus[7], caducitat: 12, distanciaMaxima: 20000)
        //manteniments.addObject(generarManteniment(managedObjectContext!, detalls: oliMotor, dades: manteniment))
        let manFiltreOli = generarManteniment(managedObjectContext!, detalls: oliMotor, dades: manteniment, vehicle: vehicle2)
        generarRegistreManteniment(managedObjectContext!, manteniment: manFiltreOli, dades: NouRegistre(distanciaInicial: 92847.7, data: formatter.dateFromString("15/08/2011")!, cost: 26.74), vehicle: vehicle2)
        
        //Manteniment Rodes
        rodes = Manteniments(tipus: kLlistaTipus[9])
        manteniment = NouManteniment(nom: kLlistaTipus[9], caducitat: 72, distanciaMaxima: 40000)
        //manteniments.addObject(generarManteniment(managedObjectContext!, detalls: rodes, dades: manteniment))
        let manRodes2 = generarManteniment(managedObjectContext!, detalls: rodes, dades: manteniment, vehicle: vehicle2)
        generarRegistreManteniment(managedObjectContext!, manteniment: manRodes2, dades: NouRegistre(distanciaInicial: 92847.7, data: formatter.dateFromString("15/08/2011")!, cost: 245.50), vehicle: vehicle2)
        
        
        //Manteniment filtre
        filtre = Manteniments(tipus: kLlistaTipus[5])
        manteniment = NouManteniment(nom: kLlistaTipus[5], caducitat: 24, distanciaMaxima: 40000)
        //manteniments.addObject(generarManteniment(managedObjectContext!, detalls: filtre, dades: manteniment))
        let manfiltre2 = generarManteniment(managedObjectContext!, detalls: filtre, dades: manteniment, vehicle: vehicle2)
        generarRegistreManteniment(managedObjectContext!, manteniment: manfiltre2, dades: NouRegistre(distanciaInicial: 92847.7, data: formatter.dateFromString("15/08/2011")!, cost: 17.96), vehicle: vehicle2)
        
        //vehicle2.manteniment = manteniments
        
        
        //crear registres manteniment
        
        
        appDelegate.saveContext()
    }
    
    private func generarVehicle(context: NSManagedObjectContext) -> Vehicle {
        let vehicle = NSEntityDescription.insertNewObjectForEntityForName("Vehicle", inManagedObjectContext: context) as! Vehicle
        
        let formatter = NSDateFormatter()
        formatter.locale = NSLocale(localeIdentifier: "ES_es")
        formatter.dateFormat = "dd/MM/yyyy"
        
        vehicle.nom = "Trialera"
        vehicle.dataAdquisicio = formatter.dateFromString("30/03/2012")!
        vehicle.dataCompra = formatter.dateFromString("29/08/2002")!
        vehicle.portes = 0
        let imageData = UIImage(named: "sherco-exemple")!
        vehicle.foto = UIImageJPEGRepresentation(imageData, 0.8)
        vehicle.marca = "Sherco"
        vehicle.model = "2002"
        vehicle.capacitat = 4.5
        vehicle.moneda = "€"
        vehicle.unitatKm = "km"
        vehicle.preu = nil
        
        return vehicle
    }
    
    private func generarVehicle2(context: NSManagedObjectContext) -> Vehicle {
        let vehicle = NSEntityDescription.insertNewObjectForEntityForName("Vehicle", inManagedObjectContext: context) as! Vehicle
        
        let formatter = NSDateFormatter()
        formatter.locale = NSLocale(localeIdentifier: "ES_es")
        formatter.dateFormat = "dd/MM/yyyy"
        
        vehicle.nom = "El meu cotxe"
        vehicle.dataAdquisicio = formatter.dateFromString("30/04/2011")!
        vehicle.dataCompra = formatter.dateFromString("29/11/2008")!
        vehicle.portes = 5
        let imageData = UIImage(named: "Megane")!
        vehicle.foto = UIImageJPEGRepresentation(imageData, 0.8)
        vehicle.marca = "Renault"
        vehicle.model = "Megane II"
        vehicle.capacitat = 64
        vehicle.moneda = "€"
        vehicle.unitatKm = "km"
        vehicle.preu = nil
        
        return vehicle
    }
    
    private func generarCarburant(context: NSManagedObjectContext, vehicle: Vehicle) -> NSMutableSet {
        //Creem llista de carburants
        var carburantVehicle = vehicle.mutableSetValueForKey("carburants")
        
        //Obtenim l'objecte de la BDD amb el carburant a afegir
        let carburantRequest = NSFetchRequest(entityName: "Carburant")
        carburantRequest.predicate = NSPredicate(format: "nom = %@", "Gasolina 98")
        carburantRequest.fetchLimit = 1
        let carburant = context.executeFetchRequest(carburantRequest, error: nil)?.first as! Carburant
        
        //L'afegim a la llista de carburants
        carburantVehicle.addObject(carburant)
        
        //Tornem la llista de carburants
        return carburantVehicle
    }
    
    private func generarCarburant2(context: NSManagedObjectContext, vehicle: Vehicle) -> NSMutableSet {
        //Creem llista carburants
        var carburantVehicle = vehicle.mutableSetValueForKey("carburants")
        
        //Obtenim carburant "Diesel"
        var carburantRequest = NSFetchRequest(entityName: "Carburant")
        carburantRequest.predicate = NSPredicate(format: "nom = %@", "Diesel")
        carburantRequest.fetchLimit = 1
        let carburant = context.executeFetchRequest(carburantRequest, error: nil)?.first as! Carburant
        
        carburantVehicle.addObject(carburant)
        
        //Obtenim carburant "Diesel Plus"
        carburantRequest = NSFetchRequest(entityName: "Carburant")
        carburantRequest.predicate = NSPredicate(format: "nom = %@", "Diesel Plus")
        carburantRequest.fetchLimit = 1
        let carburant2 = context.executeFetchRequest(carburantRequest, error: nil)?.first as! Carburant
        carburantVehicle.addObject(carburant2)
        
        //Enviem llista carburants
        return carburantVehicle
    }
    
    private func generarEmplenament(context: NSManagedObjectContext, vehicle: Vehicle, carburants: NSSet) -> NSMutableSet {
        
        var emplenaments = vehicle.mutableSetValueForKey("emplenaments")
        var km = 20534.0
        let kIncrementBaseKM = 40.0
        let kRandomKM = 13 //Constant per generar increment aleatori de KM, es generarà una diferència d'entre 0 i 12 km
        
        let kPreuBase = 1.199
        let kRandomPreu = 8 //% de diferència de preu
        var preu = 0.0
        
        let calendari = NSCalendar.currentCalendar()
        let formatter = NSDateFormatter()
        formatter.locale = NSLocale(localeIdentifier: "ES_es")
        formatter.dateFormat = "dd/MM/yyyy HH:mm:ss"
        var data = formatter.dateFromString("15/06/2013 09:15:00")!
        let intervalTemps = NSDateComponents()
        
        var anterior: [Emplenament] = []
        for var i = 0; i < 100; i++ {
            let emplenament = NSEntityDescription.insertNewObjectForEntityForName("Emplenament", inManagedObjectContext: context) as! Emplenament
            
            let diffKmAleatoria = Double(arc4random_uniform(UInt32(kRandomKM)))
            km += diffKmAleatoria + kIncrementBaseKM
            let proporcioLitres = (diffKmAleatoria / (kIncrementBaseKM + Double(kRandomKM))) + 1.0
            let litres = ((vehicle.capacitat as! Double) - 2.72) * proporcioLitres
            
            let diffPreuAleatoria = ((Double(arc4random_uniform(UInt32(kRandomPreu)))+1.0) / 100.0) + 1.0
            if Int(arc4random_uniform(UInt32(2))) == 1 { //Increment de preu
                preu = kPreuBase * diffPreuAleatoria
            } else { //Reducció de preu
                preu = kPreuBase / diffPreuAleatoria
            }
            
            intervalTemps.day = 7 //Representa que s'omple un cop per setmana a dipòsit ple
            data = calendari.dateByAddingComponents(intervalTemps, toDate: data, options: nil)!
            
            emplenament.data = data
            emplenament.km = km
            emplenament.litres = litres
            emplenament.cost = preu * litres
            emplenament.preu = preu
            emplenament.ple = NSNumber(bool: true)
            emplenament.carburant = carburants.allObjects.first as! Carburant
            emplenament.moneda = vehicle.moneda
            if i > 0 {
                emplenament.anterior = anterior.last!
            }
            anterior.append(emplenament)
            emplenaments.addObject(emplenament)
        }
        return emplenaments
    }
    
    private func generarEmplenament2(context: NSManagedObjectContext, vehicle: Vehicle, carburants: NSSet, parametres: (String, Double,Double, Double, Emplenament?)) -> Emplenament {
        let emplenament = NSEntityDescription.insertNewObjectForEntityForName("Emplenament", inManagedObjectContext: context) as! Emplenament
        emplenament.guardarDataEmplenament("\(parametres.0) 00:00:00")
        emplenament.km = parametres.1
        emplenament.litres = parametres.2
        emplenament.cost = parametres.3
        emplenament.preu = parametres.3 / parametres.2
        emplenament.ple = NSNumber(bool: true)
        emplenament.carburant = carburants.allObjects.first as! Carburant
        emplenament.moneda = vehicle.moneda
        if let anterior:Emplenament = parametres.4 {
            emplenament.anterior = anterior
        }
        return emplenament
    }
    
    private func generarSeguro(context: NSManagedObjectContext, parametres: SeguroElements) -> Seguro {
        let seguro = NSEntityDescription.insertNewObjectForEntityForName("Seguro", inManagedObjectContext: context) as! Seguro
        
        seguro.asseguradora = parametres.asseguradora
        seguro.pagament = parametres.pagament
        seguro.mesPagament = parametres.mesPagament
        seguro.preu = parametres.preu
        seguro.franquicia = parametres.franquicia
        seguro.polissa = parametres.polissa
        seguro.tipus = parametres.tipus
        seguro.notes = parametres.notes
        
        return seguro
    }
    
    private func generarImpost(context: NSManagedObjectContext, parametres: Impost) -> ImpostMunicipal {
        let impost = NSEntityDescription.insertNewObjectForEntityForName("ImpostMunicipal", inManagedObjectContext: context) as! ImpostMunicipal
        
        impost.pagament = parametres.pagament
        impost.mesPagament = parametres.mesPagament
        impost.preu = parametres.preu
        
        return impost
    }
    
    private func generarManteniment(context: NSManagedObjectContext, detalls: Manteniments, dades: NouManteniment, vehicle: Vehicle) -> Manteniment{
        let manteniment = NSEntityDescription.insertNewObjectForEntityForName("Manteniment", inManagedObjectContext: context) as! Manteniment
        
        manteniment.nom = dades.nom
        manteniment.tempsCaducitat = dades.caducitat
        manteniment.distanciaMaxima = dades.distanciaMaxima
        
        for var i = 0; i < detalls.nomsValor.count; ++i {
            let propietatNova = NSEntityDescription.insertNewObjectForEntityForName("PropietatsManteniment", inManagedObjectContext: context) as! PropietatsManteniment
            
            propietatNova.nom = detalls.nomsValor[i]
            propietatNova.tipus = detalls.tipusValor[i]
            switch propietatNova.tipus {
            case "String" :
                propietatNova.valor = detalls.placeholder[i]
            case "Double" :
                propietatNova.valor = (detalls.placeholder[i] as NSString).toDoubleValue()
            case "Text" :
                propietatNova.valor = detalls.placeholder[i]
            case "Bool" :
                if detalls.placeholder[i] == "0" {
                    propietatNova.valor = false
                } else {
                    propietatNova.valor = true
                }
            case "Number" :
                propietatNova.valor = (detalls.placeholder[i] as NSString).toDoubleValue()
            default: break
            }
            propietatNova.manteniment = manteniment
        }
        manteniment.vehicle = vehicle
        return manteniment
    }
    
    private func generarRegistreManteniment(context: NSManagedObjectContext, manteniment: Manteniment, dades: NouRegistre, vehicle: Vehicle) {
        
        let darrer = manteniment.obtenirUltimManteniment()
        
        let registreManteniment = NSEntityDescription.insertNewObjectForEntityForName("RegistreManteniment", inManagedObjectContext: context) as! RegistreManteniment
        
        
        registreManteniment.nom = manteniment.nom
        registreManteniment.distanciaMaxima = manteniment.distanciaMaxima
        registreManteniment.distanciaMuntatgeInicial = dades.distanciaInicial
        registreManteniment.data = dades.data
        registreManteniment.cost = dades.cost
        registreManteniment.moneda = Moneda(string: vehicle.moneda).simbol
        registreManteniment.distanciaMuntatgeFinal = nil
        registreManteniment.dataCanvi = nil
        registreManteniment.tempsCaducitat = manteniment.tempsCaducitat
        registreManteniment.vehicle = manteniment.vehicle
        
        for propietat in (manteniment.propietats as! NSMutableSet) {
            let propietatNova = NSEntityDescription.insertNewObjectForEntityForName("PropietatsRegistreManteniment", inManagedObjectContext: context) as! PropietatsRegistreManteniment
            
            propietatNova.nom = (propietat as! PropietatsManteniment).nom
            propietatNova.tipus = (propietat as! PropietatsManteniment).tipus
            propietatNova.valor = (propietat as! PropietatsManteniment).valor
            
            propietatNova.manteniment = registreManteniment
        }
        
        //Hi ha manteniments anteriors registrats?
        if darrer != nil {
            //Actualitzar les dades
            darrer!.distanciaMuntatgeFinal = registreManteniment.distanciaMuntatgeInicial
            darrer!.dataCanvi = registreManteniment.data
        }
    }
}