//
//  ExtensioCarburant.swift
//  Concot
//
//  Created by Andreu Font Bardolet on 17/5/15.
//  Copyright (c) 2015 Andreu Font Bardolet. All rights reserved.
//

/*
aquest document conté funcions i propietats calculades que amplien l'entitat carburant de la BDD
*/

import Foundation

extension Carburant {
    func obtenirVehicles() -> [Vehicle] {
        //Indica els vehicles que útilitzen aquest carburant
        let retornar:[Vehicle] = (self.vehicles.allObjects as! [Vehicle])
        if retornar.count > 0 {
            return retornar
        } else {
            return []
        }
    }
    
    var plural: String {
        //Retorna l'únitat de mesura del carburant el plural
        get {
            return Carburants(string: self.unitatMesura).unitatMesura.plural
        }
    }
    
    var abreviat: String {
        //retorna la versió abreviada de l'únitat de mesura dle carburant
        get {
            return Carburants(string: self.unitatMesura).unitatMesura.unitatMesura
        }
    }
    var singular: String {
        //retorna la versió singular de l'unitat de mesura del carburant
        get {
            return Carburants(string: self.unitatMesura).unitatMesura.nom
        }
    }
    
    
}
