//
//  ExtensioPagament.swift
//  Concot
//
//  Created by Andreu Font Bardolet on 5/6/15.
//  Copyright (c) 2015 Andreu Font Bardolet. All rights reserved.
//

/*
Aquest document amplia les funcions de l'entitat Pagament de la BDD i conseqüentment les entitats filles (on es faràn servir les funcions)
*/

import Foundation

extension Pagament {
    func obtenirData() -> String {
        //Retorna la data de pagament en format string
        let formatter = NSDateFormatter()
        formatter.locale = NSLocale(localeIdentifier: "ES_es")
        //formatter.dateFormat = "E, dd MMM yyyy HH:mm:ss Z"
        formatter.dateFormat = "dd/MM/yyyy"
        return formatter.stringFromDate(self.data)
    }
    
    func guardarData(entrada: String) {
        //Guarda la data de pagament a partir d'un string
        if entrada != "" {
            self.data = self.stringADataTemps(entrada)
        }
    }
    
    private func stringADataTemps(entrada: String) -> NSDate {
        //Transfomra un string que conté una data a format NSDate
        let formatter = NSDateFormatter()
        formatter.locale = NSLocale(localeIdentifier: "ES_es")
        //formatter.dateFormat = "E, dd MMM yyyy HH:mm:ss Z"
        formatter.dateFormat = "dd/MM/yyyy HH:mm:ss"
        if let retorn = formatter.dateFromString(entrada) {
            return retorn
        } else {
            formatter.dateFormat = "dd/MM/yyyy"
            return formatter.dateFromString(entrada)!
        }
    }
    
    var costDouble: Double {
        //Retorna el cost en forma double
        get {
            return Double(self.cost)
        }
    }
}