//
//  GeneralViewController.swift
//  Concot
//
//  Created by Andreu Font Bardolet on 7/5/15.
//  Copyright (c) 2015 Andreu Font Bardolet. All rights reserved.
//

import UIKit

class GeneralViewController: UITableViewController {
    

    @IBOutlet weak var fotoVehicleImage: UIImageView!
    
    //Elements gràfic
    @IBOutlet weak var GraficVehicle: GraphView!
    @IBOutlet weak var columna1Label: UILabel!
    @IBOutlet weak var columna2Label: UILabel!
    @IBOutlet weak var columna3Label: UILabel!
    @IBOutlet weak var columna4Label: UILabel!
    @IBOutlet weak var columna5Label: UILabel!
    @IBOutlet weak var columna6Label: UILabel!
    @IBOutlet weak var columna7Label: UILabel!
    @IBOutlet weak var maxLabel: UILabel!
    @IBOutlet weak var migLabel: UILabel!
    @IBOutlet weak var minLabel: UILabel!
    @IBOutlet weak var nomGrafic: UILabel!
    @IBOutlet weak var consumActualLabel: UILabel!
    @IBOutlet weak var consumMigLabel: UILabel!
    
    var vehicle: Vehicle! = nil
    
    typealias tuplaElement = (nom:String, valor:String)
    typealias tuplaSeccio = (nom:String?, elements:[tuplaElement], nota:String?)
    
    
    var elements: [tuplaSeccio] = []
    
    
    //Usat per guardar/obtenir darrer vehicle obert
    private let defaults = NSUserDefaults.standardUserDefaults()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        fotoVehicleImage.layer.borderWidth=0.0
        fotoVehicleImage.layer.masksToBounds = false
        fotoVehicleImage.layer.borderWidth = 0
        fotoVehicleImage.layer.cornerRadius = 13
        fotoVehicleImage.layer.cornerRadius = fotoVehicleImage.frame.size.height/2
        fotoVehicleImage.clipsToBounds = true



        // Do any additional setup after loading the view.
        if let vehicleObj = self.vehicle {
            
            //S'ha obert aquesta vista amb un Vehicle ja difinit, es guarda com a vehicle predefinit
            defaults.setObject(vehicle.nom, forKey: "Vehicle")
            
            //Temporal per proves
            defaults.synchronize()
            //Fi temporal per proves
            
            self.configurarVista()
            
        } else if carregarVehicle() {  //No hi ha cap vehicle assignat a la vista, cal carregar un vehicle (preferiblement l'últim usat)
            (self.tabBarController as! TabBarController).vehicle = vehicle
            (self.tabBarController as! TabBarController).title = vehicle.nom
            /*if let navigationController = self.parentViewController as? UINavigationController {
                if let tabBarController = navigationController.parentViewController as? TabBarController {
                    tabBarController.navigationItem.title = vehicle.nom
                }
            }*/
            self.configurarVista()
        } else {
            //Pendent d'estudiar com fer que no es mostri aquesta vista en blanc quan no existeix cap vehicle per mostrar en un dispositiu de tipus tauleta o un phablet en mode horitzontal
        }
    }
    
    override func viewDidAppear(animated: Bool) {
        if let test = self.vehicle {
            self.configurarVista()
        }
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    //MARK: - TableView functions
    
    override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        // #warning Potentially incomplete method implementation.
        // Return the number of sections.
        return elements.count
    }
    
    override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // #warning Incomplete method implementation.
        // Return the number of rows in the section.
        //return (vehicles.count + 1)
        return elements[section].elements.count
    }
    
    override func tableView(tableView: UITableView, titleForHeaderInSection section: Int) -> String? {
        return elements[section].nom
    }
    
    override func tableView(tableView: UITableView, titleForFooterInSection section: Int) -> String? {
        return elements[section].nota
    }
    
    override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        var cell: UITableViewCell
        //cell = tableView.dequeueReusableCellWithIdentifier("resumCell", forIndexPath: indexPath) as! AfegirVehicleCell
        cell = tableView.dequeueReusableCellWithIdentifier("rightDetailCell", forIndexPath: indexPath) as! UITableViewCell
        let element: tuplaElement = elements[indexPath.section].elements[indexPath.row]
        
        cell.textLabel?.text = elements[indexPath.section].elements[indexPath.row].nom
        cell.detailTextLabel?.text = elements[indexPath.section].elements[indexPath.row].valor
        
        return cell
    }
    
    // MARK: - Funcions
    private func configurarVista() {
        //Configura/actualitza les dades que es mostren per pantalla
        if let vehicleObj = self.vehicle {

            fotoVehicleImage.image = UIImage(data: vehicleObj.foto)
            
            omplirGraficGeneral()
            
            let unitatMesura = Quantitat(string: vehicle.obtenirDarrerCarburant()?.unitatMesura ?? "l").unitatMesura
            let moneda = Moneda(string: vehicle.moneda).simbol
            let unitatDistancia = Distancia(string: vehicle.unitatKm).unitatMesura
            
            var seccio: tuplaSeccio = tuplaSeccio(nil,[],nil)
            //Dades secció 1
            var element: tuplaElement = ("","")
            element.nom = "Cost diari"
            var valor = vehicle.previsioDeCostDiari().format(".2")
            element.valor = "\(valor) \(Moneda(string: vehicle.moneda).simbol)/dia"
            seccio.elements.append(element)
            
            element.nom = "Cost mensual"
            valor = (vehicle.previsioDeCostDiari() * 30.0).format(".2")
            element.valor = "\(valor) \(Moneda(string: vehicle.moneda).simbol)/mes"
            seccio.elements.append(element)
            
            element.nom = "Consum mig"
            valor = ((vehicle.obtenirCostPerUnitatDistancia() ?? 0) * 100.0).format(".2")
            element.valor = "\(valor) \(moneda)/100\(unitatDistancia)"
            seccio.elements.append(element)
            
            element.nom = "Distancia mitja recorreguda"
            valor = vehicle.distanciaDiariaRecorreguda().format(".2")
            element.valor = "\(valor) \(unitatDistancia)/dia"
            seccio.elements.append(element)
            
            elements.append(seccio)
            
            seccio = tuplaSeccio(nil,[],nil)
            seccio.nom = "Costs sense usar el vehicle"
            
            element.nom = "Total"
            valor = vehicle.obtenirCostDiari().format(".2")
            element.valor = "\(valor) \(moneda)/dia"
            seccio.elements.append(element)
            
            element.nom = "Impostos"
            valor = vehicle.costDiariImpost().format(".2")
            element.valor = "\(valor) \(moneda)/dia"
            seccio.elements.append(element)
            
            element.nom = "Seguro"
            valor = vehicle.costDiariSeguro().format(".2")
            element.valor = "\(valor) \(moneda)/dia"
            seccio.elements.append(element)
            
            elements.append(seccio)
            
            seccio = tuplaSeccio(nil,[],nil)
            seccio.nom = "Costs de desplaçaments"
            
            element.nom = "Total"
            valor = ((vehicle.obtenirCostPerUnitatDistancia() ?? 0) * 100.0).format(".2")
            element.valor = "\(valor) \(moneda)/100\(unitatDistancia)"
            seccio.elements.append(element)
            
            element.nom = "Carburant"
            valor = ((vehicle.obtenirCostCarburantPerUnitatDistancia() ?? 0) * 100.0).format(".2")
            element.valor = "\(valor) \(moneda)/100\(unitatDistancia)"
            seccio.elements.append(element)
            
            element.nom = "Desgast"
            valor = ((vehicle.obtenirCostDesgastPerUnitatDistancia() ?? 0) * 100.0).format(".2")
            element.valor = "\(valor) \(moneda)/100\(unitatDistancia)"
            seccio.elements.append(element)
            
            elements.append(seccio)
            
            seccio = tuplaSeccio(nil,[],nil)
            seccio.nom = "Despeses acumulades"
            
            element.nom = "Carburant posat"
            valor = vehicle.totalCarburantPosat().format(".2")
            element.valor = "\(valor) \(unitatMesura)"
            seccio.elements.append(element)
            
            element.nom = "Distància recorreguda"
            valor = vehicle.contaquilometres.format(".2")
            element.valor = "\(valor) \(unitatDistancia)"
            seccio.elements.append(element)
            
            element.nom = "Diners gastats en carburant"
            valor = vehicle.totalCarburantPagat().format(".2")
            element.valor = "\(valor) \(moneda)"
            seccio.elements.append(element)
            
            element.nom = "Diners gastats en manteniment"
            valor = vehicle.totalMantenimentPagat().format(".2")
            element.valor = "\(valor) \(moneda)"
            seccio.elements.append(element)
            
            element.nom = "Diners gastats en imposts i seguro"
            valor = vehicle.totalImpostosPagat().format(".2")
            element.valor = "\(valor) \(moneda)"
            seccio.elements.append(element)
            
            element.nom = "Diners gastats totals"
            valor = vehicle.totalPagat().format(".2")
            element.valor = "\(valor) \(moneda)"
            seccio.elements.append(element)
            
            elements.append(seccio)
        }
    }
    
    private func omplirGraficGeneral() {
        //Establir format de les dates, mostrar num de dia i nom curt del mes
        let formatter = NSDateFormatter()
        formatter.locale = NSLocale(localeIdentifier: "ES_es")
        formatter.dateFormat = "dd MMM"
        
        let darrersConsums = vehicle.obtenirConsums(30)
        GraficVehicle.graphPoints = darrersConsums.0
        
        let darreresDates = darrersConsums.1.reverse()
        var unitatCarburant = "l"
        if let carburant = (vehicle.carburants.allObjects.first as? Carburant) {
            unitatCarburant = carburant.abreviat
        }
        
        nomGrafic.text = "Històric de consum en \(unitatCarburant)/100\(vehicle.unitatKm)"
        
        if darreresDates.count >= 0 {
            if darreresDates.count >= 2{
                let max = maxElement(darrersConsums.0)
                let min = minElement(darrersConsums.0)
                maxLabel.text = Double(max).format(".1")
                migLabel.text = Double((max+min) / 2.0).format(".1")
                minLabel.text = Double(min).format(".1")
                let consumActual = Double(darrersConsums.0[0]).format(".3")
                var suma = 0.0
                for valor:Double in darrersConsums.0 {
                    suma += valor
                }
                let consumMig = Double(suma / Double(darrersConsums.0.count)).format(".3")
                consumActualLabel.text = "\(consumActual)"
                consumMigLabel.text = "\(consumMig)"
            }
            switch darreresDates.count {
            case 0...1 :
                columna1Label.text = ""
                columna2Label.text = ""
                columna3Label.text = ""
                columna4Label.text = ""
                columna5Label.text = ""
                columna6Label.text = ""
                columna7Label.text = ""
            case 2 :
                columna1Label.text = formatter.stringFromDate(darreresDates[0])
                columna2Label.text = ""
                columna3Label.text = ""
                columna4Label.text = ""
                columna5Label.text = ""
                columna6Label.text = ""
                columna7Label.text = formatter.stringFromDate(darreresDates[1])
            case 3:
                columna1Label.text = formatter.stringFromDate(darreresDates[0])
                columna2Label.text = ""
                columna3Label.text = ""
                columna4Label.text = formatter.stringFromDate(darreresDates[1])
                columna5Label.text = ""
                columna6Label.text = ""
                columna7Label.text = formatter.stringFromDate(darreresDates[2])
            case 4...6:
                columna1Label.text = formatter.stringFromDate(darreresDates[0])
                columna2Label.text = ""
                columna3Label.text = formatter.stringFromDate(darreresDates[1])
                columna4Label.text = ""
                columna5Label.text = formatter.stringFromDate(darreresDates[2])
                columna6Label.text = ""
                columna7Label.text = formatter.stringFromDate(darreresDates[3])
            case 5:
                columna1Label.text = formatter.stringFromDate(darreresDates[0])
                columna2Label.text = ""
                columna3Label.text = formatter.stringFromDate(darreresDates[1])
                columna4Label.text = ""
                columna5Label.text = formatter.stringFromDate(darreresDates[3])
                columna6Label.text = ""
                columna7Label.text = formatter.stringFromDate(darreresDates[4])
            case 6:
                columna1Label.text = formatter.stringFromDate(darreresDates[0])
                columna2Label.text = ""
                columna3Label.text = formatter.stringFromDate(darreresDates[2])
                columna4Label.text = ""
                columna5Label.text = formatter.stringFromDate(darreresDates[3])
                columna6Label.text = ""
                columna7Label.text = formatter.stringFromDate(darreresDates[5])
            default: //la resta de casos (7 o més gran)
                let part: Double = Double(darreresDates.count) / 7.0
                let segon: Int = Int(round(part))
                let tercer: Int = Int(round(part*2))
                let mig: Int = Int(darreresDates.count / 2)
                let cinque: Int = darreresDates.count - 1 - tercer
                let sise: Int = darreresDates.count - 1 - segon
                columna1Label.text = formatter.stringFromDate(darreresDates.first!)
                columna2Label.text = formatter.stringFromDate(darreresDates[segon])
                columna3Label.text = formatter.stringFromDate(darreresDates[tercer])
                columna4Label.text = formatter.stringFromDate(darreresDates[mig])
                columna5Label.text = formatter.stringFromDate(darreresDates[cinque])
                columna6Label.text = formatter.stringFromDate(darreresDates[sise])
                columna7Label.text = formatter.stringFromDate(darreresDates.last!)
            }
        }else{
            columna1Label.text = ""
            columna2Label.text = ""
            columna3Label.text = ""
            columna4Label.text = ""
            columna5Label.text = ""
            columna6Label.text = ""
            columna7Label.text = ""
            maxLabel.text = ""
            migLabel.text = ""
            minLabel.text = ""
        }
    }
    
    private func carregarVehicle() -> Bool {
        let consulta = Consultes()
        
        //Provar d'obtenir darrer vehicle usat
        if let plist = defaults.stringForKey("Vehicle") { //Hi ha un darrer vehicle usat?
            //Obtenir el vehicle
            if let vehicleObj = consulta.obtenirVehicle(plist) { //S'ha pogut obtenir?
                vehicle = vehicleObj
                return true
            } else {
                //Últim vehicle inxesistent, eliminar-lo com a últim vehicle usat
                defaults.removeObjectForKey("Vehicle")
                defaults.synchronize()
                //carregar un cotxe qualsevol
            }
        }
        
        //Si arribem aquí és que no hi ha cap darrer vehicle usat, es carrega un vehicle qualsevol
        if let vehicleObj = consulta.obtenirPrimerVehicle() {
            vehicle = vehicleObj
            return true
        } else {
            return false
        }
    }
}
