//
//  MantenimentViewController.swift
//  Concot
//
//  Created by Andreu Font Bardolet on 2/6/15.
//  Copyright (c) 2015 Andreu Font Bardolet. All rights reserved.
//

import UIKit

class MantenimentViewController: UITableViewController {
    
    var vehicle: Vehicle!

    override func viewDidLoad() {
        super.viewDidLoad()
        
        vehicle = (self.tabBarController as! TabBarController).vehicle
    }
    
    override func viewDidAppear(animated: Bool) {
        //vehicle = (self.tabBarController as! TabBarController).vehicle
        self.tableView.reloadData()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    // MARK: - Table view data source

    override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        // #warning Potentially incomplete method implementation.
        // Return the number of sections.
        return 2
    }
    
    override func tableView(tableView: UITableView, titleForHeaderInSection section: Int) -> String? {
        switch section {
        case 1: return "Historial de manteniments"
        default: return nil
        }
    }
    
    override func tableView(tableView: UITableView, titleForFooterInSection section: Int) -> String? {
        switch section {
        case 1:
            if (vehicle.registreManteniment?.count ?? 0) == 0 {
                return "Encara no s'ha registrat cap manteniment"
            } else {
                return nil
            }
        default: return nil
        }
    }

    override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // #warning Incomplete method implementation.
        // Return the number of rows in the section.
        switch section {
            case 0: return (vehicle.manteniment?.count ?? 0) + 1
            case 1: return vehicle.registreManteniment?.count ?? 0
            default: return 0
        }
    }

    override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        var cell: UITableViewCell
        // Configure the cell...
        if indexPath.section == 0 {
            //Mostrar opció manteniment nou
            if (vehicle.manteniment?.count ?? 0) == indexPath.row {
                cell = tableView.dequeueReusableCellWithIdentifier("afegirMantenimentCell", forIndexPath: indexPath) as! UITableViewCell
            } else {
                let cela = tableView.dequeueReusableCellWithIdentifier("estatMantenimentCell", forIndexPath: indexPath) as! EstatMantenimentCell
                self.configurarCelaManteniment(cela, atIndexPath: indexPath)
                cell = cela
            }
        } else {
            //Cal mostrar el registre de manteniments
            let cela = tableView.dequeueReusableCellWithIdentifier("registreMantenimentCell", forIndexPath: indexPath) as! RegistreMantenimentCell
            self.configurarCelaRegistreManteniment(cela, atIndexPath: indexPath)
            cell = cela
        }

        return cell
    }
    
    private func configurarCelaManteniment(cell: EstatMantenimentCell, atIndexPath indexPath: NSIndexPath) {
        let manteniment = vehicle.manteniment?.allObjects[indexPath.row] as! Manteniment
        cell.nomLabel.text = manteniment.nom
        let distanciaRestant = manteniment.distanciaRestant
        if distanciaRestant != nil {
            let distanciaRestantString = distanciaRestant!.format(".0")
            cell.properCanviLabel.text = "\(distanciaRestantString) \(Distancia(string: vehicle.unitatKm).unitatMesura)"
            if manteniment.desgast! <= 0.7 {
                cell.estatIcon.image = UIImage(named: "Ok")
                cell.estatIcon.image = cell.estatIcon.image!.imageWithRenderingMode(UIImageRenderingMode.AlwaysTemplate)
                cell.estatIcon.tintColor = UIColor.greenColor()
            } else if manteniment.desgast! > 0.7 && manteniment.desgast! < 0.9 {
                cell.estatIcon.image = UIImage(named: "Regular")
                cell.estatIcon.image = cell.estatIcon.image!.imageWithRenderingMode(UIImageRenderingMode.AlwaysTemplate)
                cell.estatIcon.tintColor = UIColor.yellowColor()
            } else if manteniment.desgast >= 0.9 && manteniment.desgast < 1 {
                cell.estatIcon.image = UIImage(named: "Important")
                cell.estatIcon.image = cell.estatIcon.image!.imageWithRenderingMode(UIImageRenderingMode.AlwaysTemplate)
                cell.estatIcon.tintColor = UIColor.orangeColor()
            } else if manteniment.desgast >= 1 {
                cell.estatIcon.image = UIImage(named: "Important")
                cell.estatIcon.image = cell.estatIcon.image!.imageWithRenderingMode(UIImageRenderingMode.AlwaysTemplate)
                cell.estatIcon.tintColor = UIColor.redColor()
            }
        } else {
            cell.properCanviLabel.text = "Desconegut"
            cell.estatIcon.image = UIImage(named: "Desconegut")
            cell.estatIcon.image = cell.estatIcon.image!.imageWithRenderingMode(UIImageRenderingMode.AlwaysTemplate)
            cell.estatIcon.tintColor = UIColor.blueColor()
        }
        
        
    }
    
    private func configurarCelaRegistreManteniment(cell: RegistreMantenimentCell, atIndexPath indexPath: NSIndexPath) {
        let manteniments = vehicle.obtenirRegistreManteniments()
        //let manteniment = vehicle.registreManteniment?.allObjects[indexPath.row] as! RegistreManteniment
        let manteniment = manteniments[indexPath.row]
        cell.nomLabel.text = manteniment.nom
        let cost = (manteniment.cost as! Double).format(".2")
        cell.detallLabel.text = "\(cost) \(Moneda(string: vehicle.moneda).simbol) - \(manteniment.obtenirData())"
        
        //Calcular estat del manteniment
        
        
    }

    
    // Override to support conditional editing of the table view.
    override func tableView(tableView: UITableView, canEditRowAtIndexPath indexPath: NSIndexPath) -> Bool {
        // Return NO if you do not want the specified item to be editable.
        if tableView.cellForRowAtIndexPath(indexPath)?.reuseIdentifier == "afegirMantenimentCell" {
            return false
        } else {
            return true
        }
    }
    

    
    // Override to support editing the table view.
    override func tableView(tableView: UITableView, commitEditingStyle editingStyle: UITableViewCellEditingStyle, forRowAtIndexPath indexPath: NSIndexPath) {
        if editingStyle == .Delete {
            let appDelegate = (UIApplication.sharedApplication().delegate as! AppDelegate)
            let managedObjectContext = appDelegate.managedObjectContext!
            // Delete the row from the data source
            //tableView.deleteRowsAtIndexPaths([indexPath], withRowAnimation: .Fade)
            if tableView.cellForRowAtIndexPath(indexPath)?.reuseIdentifier == "estatMantenimentCell" {
                managedObjectContext.deleteObject(vehicle.manteniment?.allObjects[indexPath.row] as! Manteniment)
            } else if tableView.cellForRowAtIndexPath(indexPath)?.reuseIdentifier == "registreMantenimentCell" {
                let manteniments = vehicle.obtenirRegistreManteniments()
                managedObjectContext.deleteObject(manteniments[indexPath.row])
                //managedObjectContext.deleteObject(vehicle.registreManteniment?.allObjects[indexPath.row] as! RegistreManteniment)
            }
            
            var error: NSError? = nil
            if !managedObjectContext.save(&error) {
                // Replace this implementation with code to handle the error appropriately.
                // abort() causes the application to generate a crash log and terminate. You should not use this function in a shipping application, although it may be useful during development.
                //println("Unresolved error \(error), \(error.userInfo)")
                abort()
            }
            //emplenaments = vehicle.obtenirEmplenaments(false)
            tableView.reloadData()
        }
    }
    

    
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        // Get the new view controller using [segue destinationViewController].
        // Pass the selected object to the new view controller.
        if let desti = segue.destinationViewController.visibleViewController as? MantenimentController {
            desti.vehicle = self.vehicle
            
            if segue.identifier == "afegirManteniment" || segue.identifier == "afegirManteniment2" {
                //No cal fer res...
            } else if segue.identifier == "editarManteniment" {
                if let indexPath = self.tableView.indexPathForSelectedRow() {
                    tableView.deselectRowAtIndexPath(indexPath, animated: true)
                    desti.manteniment = vehicle.manteniment?.allObjects[indexPath.row] as? Manteniment
                }
            } else if segue.identifier == "detallRegistreManteniment" {
                if let indexPath = self.tableView.indexPathForCell(sender as! UITableViewCell) {
                    tableView.deselectRowAtIndexPath(indexPath, animated: true)
                    desti.registreManteniment = vehicle.registreManteniment?.allObjects[indexPath.row] as? RegistreManteniment
                }
            }
        }
    }
}
