//
//  Manteniments.swift
//  Concot
//
//  Created by Andreu Font Bardolet on 4/6/15.
//  Copyright (c) 2015 Andreu Font Bardolet. All rights reserved.
//

/*
Aquest fitxer conté l'struct que defineix els tipus de manteniment suportats i les propietats de cada un, així com valors d'exemple
usant per l'app com a placeholder.
*/

import Foundation

struct Manteniments {
    let kLlistaTipus = ["Oli motor","Líquid de fre","Aigua bateria","Anticongelant","Netejavidres","Filtre d’aire","Filtre de pol·len", "Filtre d’oli", "Filtre carburant", "Rodes", "Pastilles de fre", "Neteja frens de tampó", "Corretja de distribució", "Neteja de conductes d’aire", "Transmissions"]
    
    var valors = Dictionary<String, AnyObject>()
    var nomsValor: [String] = []
    var tipusValor: [String] = []
    var placeholder: [String] = []
    var titol: [String] = []
    
    var dataManteniment: NSDate = NSDate()
    var contaquilometres: Double = Double()
    var tempsCaducitat: Double = Double()
    var distanciaDurada: Double = Double()
    var cost: Double = Double()
    
    init(){
        //Si s'inicialitza sense indicar cap tipus de manteniment, només quedarà
        //inicialitzada la llista de tipus de manteniments suportats
    }
    
    init(tipus: String) {
        
        switch tipus {
        case "Oli motor":
            
            self.nomsValor = ["Quantitat [l]", "Normativa", "Viscositat", "Arandela carter", "Marca", "Referència", "Notes"]
            self.tipusValor = ["Double", "String", "String", "String", "String", "String", "Text"]
            self.placeholder = ["4,7", "ACEA A3/B4", "10W40", "1,6 mílimetres", "ELF", "Eco Oil 10W40", ""]
            
        case "Líquid de fre":
            
            self.nomsValor = ["Quantitat [l]", "Normativa", "Viscositat", "Marca", "Referència", "Notes"]
            self.tipusValor = ["Double", "String", "String", "String", "String", "Text"]
            self.placeholder = ["2", "DOT4", "Màxim 750 mm2/s a -40", "Pioneer", "DOT-4 ABS", ""]
            
        case "Aigua bateria":
            
            self.nomsValor = ["Quantitat [cl]", "Notes"]
            self.tipusValor = ["Double", "Text"]
            self.placeholder = ["30", ""]
            
        case "Anticongelant":
            
            self.nomsValor = ["Quantitat [l]", "Graus congelació", "Marca", "Referència", "Notes"]
            self.tipusValor = ["Double", "Double", "String", "String", "Text"]
            self.placeholder = ["5", "30", "TOTAL", "Extremme Cold", ""]
            
        case "Netejavidres":
            
            self.nomsValor = ["Quantitat [l]", "Propietats", "Marca", "Referència", "Notes"]
            self.tipusValor = ["Double", "String", "String", "String", "Text"]
            self.placeholder = ["3", "Anti-mosquits", "Cecauto", "InsectClean", ""]
            
        case "Filtre d’aire":
            
            self.nomsValor = ["Marca", "Referència", "Notes"]
            self.tipusValor = ["String", "String", "Text"]
            self.placeholder = ["Millard", "R284", ""]
            
        case "Filtre de pol·len":
            
            self.nomsValor = ["Propietats", "Marca", "Referència", "Notes"]
            self.tipusValor = ["String", "String", "String", "Text"]
            self.placeholder = ["Anti-oló (carboni actiu)", "Cecauto", "active-carbon Plus", ""]
            
        case "Filtre d’oli":
            
            self.nomsValor = ["Marca", "Referència", "Notes"]
            self.tipusValor = ["String", "String", "Text"]
            self.placeholder = ["Millard", "ML-5786", ""]
            
        case "Filtre carburant":
            
            self.nomsValor = ["Marca", "Referència", "Notes"]
            self.tipusValor = ["String", "String", "Text"]
            self.placeholder = ["Millard", "MF-14727", ""]
            
        case "Rodes":
            
            self.nomsValor = ["Número de rodes", "Marca", "Referència", "Pneumàtics d'hivern", "Ample", "Perfil", "Llanta", "Índex de Velocitat", "Notes"]
            self.tipusValor = ["Number", "String", "String", "Bool", "Number", "Number", "Number", "String",  "Text"]
            self.placeholder = ["4", "Continental", " ContiVanContact 200", "", "215", "60", "16", "190 (T)", ""]
            
        case "Pastilles de fre":
            
            self.nomsValor = ["Marca", "Referència", "Sistema de frens", "Eix de muntatge", "Espessor [mm]", "Amplada [mm]", "Alçada [mm]", "Indicador desgast", "Notes"]
            self.tipusValor = ["String", "String", "String", "String", "Double", "String", "String", "Bool", "Text"]
            self.placeholder = ["Bölk", "BOL-5600", "ATE / TEVES", "Eix davanter", "18,4", "155,1 / 156,3", "68,9 / 66,8", "", ""]
            
        case "Neteja frens de tampó":
            
            self.nomsValor = ["Notes"]
            self.tipusValor = ["Text"]
            self.placeholder = [""]
            
        case "Corretja de distribució":
            
            self.nomsValor = ["Marca", "Referència", "Notes"]
            self.tipusValor = ["String", "String", "Text"]
            self.placeholder = ["Renault", "RF-57832", ""]
            
        case "Neteja de conductes d’aire":
            
            self.nomsValor = ["Notes"]
            self.tipusValor = ["Text"]
            self.placeholder = [""]
            
        case "Transmissions":
            
            self.nomsValor = ["Marca", "Referència", "Notes"]
            self.tipusValor = ["String", "String", "Text"]
            self.placeholder = ["Cepsa", "EP 90", ""]
            
        default: break
        }
    }
}