//
//  MasterViewController.swift
//  Concot
//
//  Created by Andreu Font Bardolet on 7/5/15.
//  Copyright (c) 2015 Andreu Font Bardolet. All rights reserved.
//

import UIKit
import CoreData

class MasterViewController: UITableViewController, NSFetchedResultsControllerDelegate {
    
    //var vehicles: [Vehicle] = []
    var managedObjectContext: NSManagedObjectContext? = nil
    
    override func awakeFromNib() {
        super.awakeFromNib()
    }

    override func viewDidLoad() {
        super.viewDidLoad()

        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem()
        
        //Obtenir els vehicles
        /*let request = NSFetchRequest(entityName: "Vehicle")
        let appDelegate:AppDelegate = (UIApplication.sharedApplication().delegate as! AppDelegate)
        let context:NSManagedObjectContext = appDelegate.managedObjectContext!
        vehicles = (context.executeFetchRequest(request, error: nil)!) as! [Vehicle]*/
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    // MARK: - Table view data source

    override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        // #warning Potentially incomplete method implementation.
        // Return the number of sections.
        return 1
    }

    override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // #warning Incomplete method implementation.
        // Return the number of rows in the section.
        //return (vehicles.count + 1)
        let sectionInfo = self.fetchedResultsController.sections![section] as! NSFetchedResultsSectionInfo
        return (sectionInfo.numberOfObjects + 1)
    }

    override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        var cell: UITableViewCell
        let sectionInfo = self.fetchedResultsController.sections![0] as! NSFetchedResultsSectionInfo
        if sectionInfo.numberOfObjects == indexPath.row {
            cell = tableView.dequeueReusableCellWithIdentifier("AfegirVehicleCell", forIndexPath: indexPath) as! AfegirVehicleCell
        } else {
            let cella = tableView.dequeueReusableCellWithIdentifier("VehicleCell", forIndexPath: indexPath) as! VehicleCell
            self.configurarCela(cella, atIndexPath: indexPath)
            cell = cella
        }

        return cell
    }
    
    private func configurarCela(cell: VehicleCell, atIndexPath indexPath: NSIndexPath) {
        let vehicle = fetchedResultsController.objectAtIndexPath(indexPath) as! Vehicle
        cell.nomLabel!.text = vehicle.nom
        //let stringMigCarburant = (vehicle.obtenirConsums(1).0.first as Double? ?? 0.0)!.format(".2")
        let migDiari = vehicle.previsioDeCostDiari()
        if migDiari != 0.0 {
            let stringMigDiari = migDiari.format(".2")
            cell.consumMigCarburantLabel!.text = "\(stringMigDiari) \(vehicle.moneda)/dia"
        } else {
            cell.consumMigCarburantLabel!.text = ""
        }
        
        if let migMoneda = vehicle.obtenirCostCarburantPerUnitatDistancia() {
            let stringMigMoneda = (migMoneda * 100.0).format(".2")
            cell.consumMigMonedaLabel!.text = "\(stringMigMoneda) \(vehicle.moneda)/100\(vehicle.unitatKm)"
        } else {
            cell.consumMigMonedaLabel!.text = ""
        }
        
        if vehicle.foto.length > 0 {
            cell.imatge!.image = UIImage(data: vehicle.foto)
        }
    }

    
    // Override to support conditional editing of the table view.
    override func tableView(tableView: UITableView, canEditRowAtIndexPath indexPath: NSIndexPath) -> Bool {
        // Return NO if you do not want the specified item to be editable.
        if tableView.cellForRowAtIndexPath(indexPath)?.reuseIdentifier == "AfegirVehicleCell" {
            return false
        } else {
            return true
        }
    }


    
    // Override to support editing the table view.
    override func tableView(tableView: UITableView, commitEditingStyle editingStyle: UITableViewCellEditingStyle, forRowAtIndexPath indexPath: NSIndexPath) {
        if editingStyle == .Delete {
            // Delete the row from the data source
            let context = self.fetchedResultsController.managedObjectContext
            context.deleteObject(self.fetchedResultsController.objectAtIndexPath(indexPath) as! NSManagedObject)
            
            var error: NSError? = nil
            if !context.save(&error) {
                // Replace this implementation with code to handle the error appropriately.
                // abort() causes the application to generate a crash log and terminate. You should not use this function in a shipping application, although it may be useful during development.
                //println("Unresolved error \(error), \(error.userInfo)")
                abort()
            }
        }
    }


    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        // Get the new view controller using [segue destinationViewController].
        // Pass the selected object to the new view controller.
        if segue.identifier == "obrirVehicle" {
            if let indexPath = self.tableView.indexPathForSelectedRow() {
                tableView.deselectRowAtIndexPath(indexPath, animated: true)
                let vehicle = fetchedResultsController.objectAtIndexPath(indexPath) as! Vehicle//NSManagedObject
                var desti = segue.destinationViewController as? UIViewController
                if let navigactionController = desti as? UINavigationController {
                    desti = navigactionController.visibleViewController
                    if let tabBarController = desti as? TabBarController {
                        //Passar l'objecte cotxe seleccionat al TabBar
                        tabBarController.vehicle = vehicle
                        tabBarController.navigationItem.title = vehicle.nom
                        //tabBarController.navigationItem.rightBarButtonItem?.title = "Omplir"
                        tabBarController.navigationItem.leftBarButtonItem = self.splitViewController?.displayModeButtonItem()
                        //tabBarController.navigationItem.leftBarButtonItem?.image = UIImage(named: "Menu")
                        //let backItem = UIBarButtonItem(title: "Custom Text HERE", style: .Bordered, target: nil, action: nil)
                        //tabBarController.navigationItem.backBarButtonItem = backItem
                        tabBarController.navigationItem.leftItemsSupplementBackButton = true
                        //tabBarController.navigationItem.hidesBackButton = false
                        
                        desti = tabBarController.viewControllers?.first as? UIViewController
                        if let navController2 = desti as? UINavigationController {
                            desti = navController2.visibleViewController
                            if let generalVC = desti as? GeneralViewController {
                                generalVC.vehicle = vehicle
                            }
                        }
                    }
                }
            }
        }
    }
    
    // MARK: - Fetched results controller
    var fetchedResultsController: NSFetchedResultsController {
        if _fetchedResultsController != nil {
            return _fetchedResultsController!
        }
        
        let fetchRequest = NSFetchRequest()
        // Edit the entity name as appropriate.
        let vehicle = NSEntityDescription.entityForName("Vehicle", inManagedObjectContext: self.managedObjectContext!)
        fetchRequest.entity = vehicle
        
        // Set the batch size to a suitable number.
        fetchRequest.fetchBatchSize = 20
        
        // Edit the sort key as appropriate.
        let sortDescriptor = NSSortDescriptor(key: "nom", ascending: false)
        let sortDescriptors = [sortDescriptor]
        
        fetchRequest.sortDescriptors = [sortDescriptor]
        
        // Edit the section name key path and cache name if appropriate.
        // nil for section name key path means "no sections".
        let aFetchedResultsController = NSFetchedResultsController(fetchRequest: fetchRequest, managedObjectContext: self.managedObjectContext!, sectionNameKeyPath: nil, cacheName: "Master")
        aFetchedResultsController.delegate = self
        _fetchedResultsController = aFetchedResultsController
        
        var error: NSError? = nil
        if !_fetchedResultsController!.performFetch(&error) {
            // Replace this implementation with code to handle the error appropriately.
            // abort() causes the application to generate a crash log and terminate. You should not use this function in a shipping application, although it may be useful during development.
            //println("Unresolved error \(error), \(error.userInfo)")
            abort()
        }
        
        return _fetchedResultsController!
    }
    var _fetchedResultsController: NSFetchedResultsController? = nil
    
    func controllerWillChangeContent(controller: NSFetchedResultsController) {
        self.tableView.beginUpdates()
    }
    
    func controller(controller: NSFetchedResultsController, didChangeSection sectionInfo: NSFetchedResultsSectionInfo, atIndex sectionIndex: Int, forChangeType type: NSFetchedResultsChangeType) {
        switch type {
        case .Insert:
            self.tableView.insertSections(NSIndexSet(index: sectionIndex), withRowAnimation: .Fade)
        case .Delete:
            self.tableView.deleteSections(NSIndexSet(index: sectionIndex), withRowAnimation: .Fade)
        default:
            return
        }
    }
    
    func controller(controller: NSFetchedResultsController, didChangeObject anObject: AnyObject, atIndexPath indexPath: NSIndexPath?, forChangeType type: NSFetchedResultsChangeType, newIndexPath: NSIndexPath?) {
        switch type {
        case .Insert:
            tableView.insertRowsAtIndexPaths([newIndexPath!], withRowAnimation: .Fade)
        case .Delete:
            tableView.deleteRowsAtIndexPaths([indexPath!], withRowAnimation: .Fade)
        case .Update:
            self.configurarCela(tableView.cellForRowAtIndexPath(indexPath!)! as! VehicleCell, atIndexPath: indexPath!)
        case .Move:
            tableView.deleteRowsAtIndexPaths([indexPath!], withRowAnimation: .Fade)
            tableView.insertRowsAtIndexPaths([newIndexPath!], withRowAnimation: .Fade)
        default:
            return
        }
    }
    
    func controllerDidChangeContent(controller: NSFetchedResultsController) {
        self.tableView.endUpdates()
    }
}
