//
//  Moneda.swift
//  Concot
//
//  Created by Andreu Font Bardolet on 11/5/15.
//  Copyright (c) 2015 Andreu Font Bardolet. All rights reserved.
//

/*
Aquest fitxer conté l'struct que defineix les monedes i el seu model de dades, com noms i simbols abreviats.
Els tipus de moneda que apareixen són els suportats per l'aplicació.
Al quedar fora de l'abast del projecte, CONCOT no suporta conversió de valor de moneda, així que aquest struct
tampoc conté aquesta capacitat
*/

import Foundation

struct Moneda {
    var nom = String()
    var plural = String()
    var simbol = String()
    var seleccionat: Bool = false
    
    init(){
        
    }
    
    init(string: String){
        switch string {
        case "€" :
            self.nom = "Euro"
            self.plural = "Euros"
            self.simbol = string
        case "$" :
            self.nom = "Dollar"
            self.plural = "Dollars"
            self.simbol = string
        default:
            self.nom = "Euro"
            self.plural = "Euros"
            self.simbol = "€"
        }
    }
}