//
//  Quantitat.swift
//  Concot
//
//  Created by Andreu Font Bardolet on 17/5/15.
//  Copyright (c) 2015 Andreu Font Bardolet. All rights reserved.
//

/*
Aquest fitxer conté l'struct que defineix les unitats de mesura de quantitat i el seu model de dades, com noms i simbols abreviats.
Els tipus de quantitat que apareixen són els suportats per l'aplicació, són les quantitats usades per mesurar el carburant posat.
*/

import Foundation

struct Quantitat {
    var nom: String = String()
    var plural: String = String()
    var unitatMesura: String = String()
    
    init(){
        
    }
    
    init(string: String){
        switch string {
        case "l", "Litre", "Litres" :
            self.nom = "Litre"
            self.plural = "Litres"
            self.unitatMesura = "l"
        case "m3", "Metre cúbic", "Metre cúbics" :
            self.nom = "Metre cúbic"
            self.plural = "Metres cúbics"
            self.unitatMesura = "m3"
        case "kw", "Quilo what", "Quilo whats" :
            self.nom = "Quilo what"
            self.plural = "Quilo whats"
            self.unitatMesura = "kw"
        default:
            self.nom = "Litre"
            self.plural = "Litres"
            self.unitatMesura = "l"
        }
    }
}